<template>
		<page :title="title">
			<div >
				<nuxt-link id="create" class="btn btn-success" to="/form">
					<icon class="float-left mt-1 mr-1" icon="icwt-plus" size="16" />Добавить анкету
				</nuxt-link>
			</div>
			<TablePageWrapper>
				
				<table-struct
					:columns="columns"
					:actions="actions"
					:data="paginatedItems"
					@onEdit="handleEdit"
					@onDelete="handleDelete"
				/>
			</TablePageWrapper>
			<paginate
				:page-count="pageCount"
				:click-handler="pageChangeHandler"
				:prev-text="'Назад'"
				:next-text="'Вперед'"
				:container-class="'pagination'"
				:page-class="'page-item'"
				:prev-class="'page-item'"
				:next-class="'page-item'"
				
			/>
		</page>
</template>

<script>
//Доступ к хранилищу
import { mapGetters, mapActions } from 'vuex'

//Массивы объектов для реализации таблицы
import { columns, actions } from './setup'

//Mixin для реализации пагинации
import paginationMixixn from '@/mixins/pagination.mixin'

export default {
	name: 'MainPage',
	mixins: [paginationMixixn],
	components: {
		//Компонент отображающий структуру таблицы
		Tablestruct: () => import('@/components/table/TableStruct'),
		//Компонент для стилизации таблицы
		TablePageWrapper: () => import('@/components/table/components/TablePageWrapper'),
		//Компонент для стилизации
		Page: () => import('@/components/Page'),
		//Компонент отвечающий за отображение svg иконок
		Icon: () => import('@/components/icon/Icon')
	},
	computed: {
		...mapGetters({
			items: 'questionnaires/items'
		})
	},
	data: () => ({
		columns,
		actions,
		title: 'Анкеты'
	}),
	methods: {
		...mapActions({
			'fetchItems': 'questionnaires/fetchAll',
			'deleteItem': 'questionnaires/delete'
		}),
		//Переход на форму для изменения анкеты
		handleEdit({ id }) {
			this.$router.push(`form/${id}`)
		},
		//Запрос на удаление анкеты
		async handleDelete({ id }) {
			if(confirm("Запись будет удалена. Уверены?")){
				await this.deleteItem(id)
				await this.fetchItems()
				this.setupPagination(this.items)
			}
		},
	},
	async mounted () {
		//Вызываем данные из бд
		await this.fetchItems()
		//Метод из mixins фильтрующий данные из БД для реализации пагинации
		this.setupPagination(this.items)
	}
}
</script>

<style lang="css">
.pagination{
	margin-top: 10px;
}
.page-item {
	padding: 6px;
	padding-left: 13px;
	padding-right: 13px;
	border-style: solid;
	border-width: 1px;
	border-color: #9d9d9e;
	background: white;
	font-size: 15px;
	color: #789bff;
}
li.page-item.active{ 
	background: #5b91ff;
	color: white;
}
</style>
